/************************************************************
	FILE: lib_math.h
          prototypes for lib_math.C
************************************************************/
 
#ifdef WIN32
#define M_PI 3.1415926
#endif

void plotstate(FILE *fp, float *x, int n);
int lin_eq_solv(MAT a, float *b, float *x, int n);
int ludcmp(MAT a, int n, int *indx, float *d);
void lubksb(MAT a, int n, int *indx, float b[]);
float *vector(int nl, int nh);
void free_vector(float *v, int nl, int nh);
void nrerror(STR str);
void matinv(MAT a, int size);
void tm_matinv(Matrix a);
void prmat(MAT a, int size);
void mvmult(float *x, MAT a, float *b, int size);
void matcopy(MAT, MAT, int size);
void tm_copy(GLmatrix, GLmatrix);
void matmult(MAT aa, MAT a1, MAT a2, int size);
void prfvec(FVEC v);
void vecsub(FVEC ans, FVEC a, FVEC b);
void vecadd(FVEC ans, FVEC a, FVEC b);
float vecsize(FVEC v);
void idenmat(Matrix m);
void tmmult(FVEC a, Matrix m, FVEC v);
void tminv(Matrix minv, Matrix m);
void prvec(FVEC v);
void prvecf(FILE *fp, FVEC v);
void getcol(FVEC v, Matrix m, int col);
void putcol(FVEC v, Matrix m, int col);
void xprod(FVEC v, FVEC a, FVEC b);
void xprodnorm(FVEC v, FVEC a, FVEC b);
void norm(FVEC v);
void prtm(Matrix m);
void prtmf(FILE *f, Matrix m);
void rdtmf(FILE *f, Matrix m);
void veccp(FVEC a, FVEC b);
void tmmmult(Matrix ans, Matrix a, Matrix b);
void tmcopy(Matrix b, Matrix a);
void solv_quad(float a, float b,
		  float c, float *x1, float *x2);
void mat2rpy(Matrix mat, FVEC rpy);
void rpy2mat(FVEC rpy, Matrix mat);
void rotmat(char axis, float theta, Matrix mat);
void tmtransp(Matrix tpmat, Matrix mat);
void vecinit(FVEC v);
void rotkth(Matrix mat, FVEC k, float th);
void rotkthi(FVEC k, float *th, Matrix mat);
void mat2q(FVEC q, Matrix m);
void rot_mat2(float q[], Matrix m);







